const FIREFLY_XUL_FILE = "chrome://firefly/content/firefly.xul"
const FIREFLY_APP_NAME = "Firefly"
var fireflyIdNum=1;
var fireflyTimeout;
var fireflyDirName;
var gFireflySelectedFiles;
var fireflyMode=Array('tree','list','tiles','thumbnails');

function translate(str) {
	return document.getElementById('fireflyStrings').getString(str);
}
function inArray(array,value) {
// Returns true if the passed value is found in the
// array.  Returns false if it is not.
    var i;
    for (i=0; i < array.length; i++) {
        // Matches identical (===), not just similar (==).
        if (array[i] === value) {
            return true;
        }
    }
    return false;
}

function newSampleTab() {			// creating the new tab that will host Firefly
	try {
		var newTab = gBrowser.addTab(FIREFLY_XUL_FILE);
		newTab.setAttribute(FIREFLY_APP_NAME, 'true');
		newTab.setAttribute('class','tabbrowser-tab');
		newTab.label = FIREFLY_APP_NAME;
		getBrowser().selectedTab = newTab;
	} catch (e) {
		errorLogger(e);
	}
}

function openTreeSidebar() {	// opens the sidebar with the directory tree in it
	try {
		//var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var win = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
			   .getInterface(Components.interfaces.nsIWebNavigation)
			   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
			   .rootTreeItem
			   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
			   .getInterface(Components.interfaces.nsIDOMWindow);
		win.toggleSidebar('viewFoldersSidebar');
	} catch (e) {
		errorLogger(e);
	}
}

function nameSort(el1,el2) {
	/* Sort by file name */
	if (getCurrent()) {
		var sortDir=getCurrent().getAttribute('sortDir');
	} else {
		var sortDir='asc'
	}
	if (el1.leafName.toUpperCase()>el2.leafName.toUpperCase()) {
		if (sortDir=='asc') {
			return -1;
		} else {
			return 1;
		}
	} else if (el2.leafName.toUpperCase()>el1.leafName.toUpperCase()) {
		if (sortDir=='asc') {
			return 1;
		} else {
			return -1;
		}
	} else {
		return 0;
	}
}
function extSort(el1,el2) {
	/* Sort by file extension */
	if (getCurrent()) {
		var sortDir=getCurrent().getAttribute('sortDir');
	} else {
		var sortDir='asc'
	}
	el1Ext=el1.leafName.substring(el1.leafName.lastIndexOf('.')+1).toUpperCase();
	el2Ext=el2.leafName.substring(el2.leafName.lastIndexOf('.')+1).toUpperCase();
	if (el1Ext>el2Ext) {
		if (sortDir=='asc') {
			return 1;
		} else {
			return -1;
		}
	} else if (el2Ext>el1Ext) {
		if (sortDir=='asc') {
			return -1;
		} else {
			return 1;
		}
	} else {
		return 0;
	}
}
function sizeSort(el1,el2) {
	/* Sort by file size */
	if (getCurrent()) {
		var sortDir=getCurrent().getAttribute('sortDir');
	} else {
		var sortDir='asc'
	}
	if (el1.fileSize>el2.fileSize) {
		if (sortDir=='asc') {
			return 1;
		} else {
			return -1;
		}
	} else if (el2.fileSize>el1.fileSize) {
		if (sortDir=='asc') {
			return -1;
		} else {
			return 1;
		}
	} else {
		return 0;
	}
}
function dateSort(el1,el2) {
	/* Sort by file date */
	if (getCurrent()) {
		var sortDir=getCurrent().getAttribute('sortDir');
	} else {
		var sortDir='asc'
	}
	if (el1.lastModifiedTime>el2.lastModifiedTime) {
		if (sortDir=='asc') {
			return 1;
		} else {
			return -1;
		}
	} else if (el2.lastModifiedTime>el1.lastModifiedTime) {
		if (sortDir=='asc') {
			return -1;
		} else {
			return 1;
		}
	} else {
		return 0;
	}
}

function getFiles(path,useSort) {			// gets the files from a directory
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var showHiddenFiles=prefs.getBoolPref('extensions.firefly.hidden_files');

	var filter=getCurrent().getAttribute('filter');
	if (!prefs.getBoolPref('extensions.firefly.regex_filter')) {
		// convert *.* and similar to a valid regular expression
		var s='';
		s+='^';
		for (var i = 0; i<filter.length; i++) {
		    var c = filter.charAt(i);
		    switch(c) {
			case '*':
			    s+=".*";
			    break;
			case '?':
			    s+=".";
			    break;
			    // escape special regexp-characters
			case '(': case ')': case '[': case ']': case '$':
			case '^': case '.': case '{': case '}': case '|':
			case '\\':
			    s+="\\";
			    s+=c;
			    break;
			default:
			    s+=c;
			    break;
		    }
		}
		s+='$';
		filter=s;
	}
	if (filter=='' || filter=='^$') {
		filter='^.*$';
	}
	var filesANDdirs=new Array();
	var files=new Array();
	var dirs=new Array();
	var next;
	try {
		//if (getCurrent().path.indexOf('search in:')!=-1 || getCurrent().path.indexOf('search:')!=-1) {
		if (getCurrent().type=='search') {
			var newFiles=getCurrent().files;
			var newDirs=getCurrent().dirs;
			for (var i=0;i<newFiles.length;i++) {
				if (newFiles[i].leafName.toLowerCase().match(filter.toLowerCase())) {
					files.push(newFiles[i]);
				}
			}
			for (var i=0;i<newDirs.length;i++) {
				if (newDirs[i].leafName.toLowerCase().match(filter.toLowerCase())) {
					dirs.push(newDirs[i]);
				}
			}
		} else {
			var start = new Date();
			var aFolder = Components.classes["@mozilla.org/file/local;1"].createInstance();
			if (aFolder) aFolder.QueryInterface(Components.interfaces.nsILocalFile);
			aFolder.initWithPath(path);
			var folderEntries=aFolder.directoryEntries;
			while (folderEntries.hasMoreElements()) {
				next=folderEntries.getNext().QueryInterface(Components.interfaces.nsILocalFile);

				if (next.leafName.toLowerCase().match(filter.toLowerCase())) {

					if ((next.isHidden() && showHiddenFiles) || (!next.isHidden())) {
						if (next.isDirectory()) {
							dirs.push(next);
						} else {
							files.push(next);
						}
					}

				}
			}
			
			var med = new Date();
		}
		if (useSort==null) {
			var sortBy=getCurrent().getAttribute('sortby');
		} else {
			var sortBy=useSort;
		}
		switch (sortBy) {
			case 'name':
				dirs.sort(nameSort);
				files.sort(nameSort);
				break;
			case 'extension':
				dirs.sort(nameSort);
				files.sort(extSort);
				break;
			case 'size':
				dirs.sort(nameSort);
				files.sort(sizeSort);
				break;
			case 'date':
				dirs.sort(dateSort);
				files.sort(dateSort);
				break;
			default :
				dirs.sort(nameSort);
				files.sort(nameSort);
				break;
		}
		filesANDdirs=Array.concat(dirs,files);
		var stop = new Date();
		//alert(filesANDdirs.length+'|'+(med.getTime()-start.getTime())+'|'+(stop.getTime()-start.getTime())+'|'+(stop.getTime()-med.getTime()));
	} catch (e) {
		errorLogger(e);
	}
	return filesANDdirs;
}



function eraseContent(el) {		// erases all children of a tag
	var cycles=el.childNodes.length;
	for (var p=0;p<cycles;p++) {
		el.removeChild(el.childNodes[0]);
	}
}

function setUpHoveredElement(el) {		// sets the file path to an attribute of the tooltip
	var tooltipEl=document.getElementById('fileInfo');
	var path;//=getCurrent().path;
	path=el.getAttribute('parentPath');
	try {
		var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance();
		if (aFile) aFile.QueryInterface(Components.interfaces.nsILocalFile);
		aFile.initWithPath(path);
		aFile.append(el.firstChild.nextSibling.value);
		tooltipEl.setAttribute('filePath',aFile.path);
	} catch (e) {
		errorLogger(e);
	}
}


function treeMouseover(event,tree) {		// sets the file path to an attribute of the tooltip for the tree view
	var tooltipEl=document.getElementById('fileInfo');
	var row=tree.treeBoxObject.getRowAt(event.clientX,event.clientY);
	
	if (row!=-1) {
		//var path=tree.parentNode.parentNode.parentNode.getAttribute('path');
		var path=tree.view.getCellText(row,event.target.parentNode.columns['path']);
		try {
			var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance();
			if (aFile) aFile.QueryInterface(Components.interfaces.nsILocalFile);
			aFile.initWithPath(path);
			aFile.append(tree.view.getCellText(row,tree.columns['treename']));
			tooltipEl.setAttribute('filePath',aFile.path);
		} catch (e) {
			errorLogger(e);
		}
	} else {
		tooltipEl.setAttribute('filePath','');
	}
//	window.status=path;
}


function createTooltip(el) {		// creates the content of the tooltip taking the path from the attribute
	var path=el.getAttribute('filePath');
	var fireflyDirSize;
	if (path!='') {
		var newDescription;
		try {
			var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance();
			if (aFile) aFile.QueryInterface(Components.interfaces.nsILocalFile);
			aFile.initWithPath(path);
			var extension=aFile.leafName.substring(aFile.leafName.lastIndexOf('.')+1).toLowerCase();
		} catch (e) {
			errorLogger(e);
		}

		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var MOVIE_TYPES=prefs.getCharPref('extensions.firefly.movie_types').toLowerCase();
		var MUSIC_TYPES=prefs.getCharPref('extensions.firefly.music_types').toLowerCase();
		var IMAGE_TYPES=prefs.getCharPref('extensions.firefly.image_types').toLowerCase();
		
		var filePath='file://'+aFile.path;
		if (IMAGE_TYPES.indexOf(extension)!=-1) {						// if the File is an Image File the Image will be shown else the icon
			var newImage=document.createElement('image');
			newImage.setAttribute('flex','1');
			newImage.setAttribute('src',filePath);
			el.appendChild(newImage);		
		}
		if (MOVIE_TYPES.indexOf(extension)!=-1 && pluginExists('VLC multimedia plugin')) {
			var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			var autoPlayFiles=prefs.getBoolPref('extensions.firefly.auto_play');
			if (autoPlayFiles) {
				try {
					var newMovie=document.createElementNS('http://www.w3.org/1999/xhtml','embed');
					newMovie.setAttribute('type','application/x-vlc-plugin');
					newMovie.setAttribute('id','tooltipVideo');
					newMovie.setAttribute('width','400');
					newMovie.setAttribute('height','300');
					newMovie.setAttribute('src',filePath);
					newMovie.setAttribute('loop','yes');
					el.appendChild(newMovie);
					document.getElementById('firefly_addresbox').focus();
					document.getElementById('fileInfo').focus();
					document.getElementById('tooltipVideo').play();
					var newProgress=document.createElement('progressmeter');
					newProgress.setAttribute('id','tooltipProgress');
					newProgress.setAttribute('style','width:400px;');
					el.appendChild(newProgress);
					doTimer();
				} catch (e) {
					errorLogger(e);
				}
			}
		}
		if (MUSIC_TYPES.indexOf(extension)!=-1 && pluginExists('VLC multimedia plugin')) {
			var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			var autoPlayFiles=prefs.getBoolPref('extensions.firefly.auto_play');
			if (autoPlayFiles) {
				try {
					var newMusic=document.createElementNS('http://www.w3.org/1999/xhtml','embed');
					newMusic.setAttribute('type','application/x-vlc-plugin');
					newMusic.setAttribute('id','tooltipVideo');
					newMusic.setAttribute('width','0');
					newMusic.setAttribute('height','0');
					newMusic.setAttribute('src',filePath);
					newMusic.setAttribute('loop','yes');
					el.appendChild(newMusic);
					document.getElementById('firefly_addresbox').focus();
					document.getElementById('fileInfo').focus();
					document.getElementById('tooltipVideo').play();
					var newProgress=document.createElement('progressmeter');
					newProgress.setAttribute('id','tooltipProgress');
					el.appendChild(newProgress);
					doTimer();
				} catch (e) {
					errorLogger(e);
				}
			}
		}

		var newBox=document.createElement('vbox');
		
		newDescription=document.createElement('description');
		newDescription.setAttribute('value',translate('nameTooltip')+' '+aFile.leafName);
		newBox.appendChild(newDescription);
		newDescription=document.createElement('description');
		newDescription.id='tooltipPath';
		newDescription.setAttribute('value',translate('pathTooltip')+' '+aFile.path);
		newBox.appendChild(newDescription);
		el.setAttribute('currentPath',aFile.path);

		if (aFile.isDirectory() && prefs.getBoolPref('extensions.firefly.calculate_dir_size')) {
			fireflyDirSize=0;
		} else {
			fireflyDirSize=aFile.fileSize;
		}
		
		newDescription=document.createElement('description');
		newDescription.setAttribute('id','fileSize');
		newDescription.setAttribute('size',fireflyDirSize);
		newDescription.setAttribute('value',translate('sizeTooltip')+' '+Math.ceil(fireflyDirSize/1024)+' '+translate('kbProgress'));
		newBox.appendChild(newDescription);
		
		el.appendChild(newBox);
		if (aFile.isDirectory() && prefs.getBoolPref('extensions.firefly.calculate_dir_size')) {
			dirSizeCalc(aFile.path,0);
		}
	}
}

function split(el,direction) {
	/* Splits the view horizontally ot vertically depending on deirection argument */
	try {
		var parent=el.parentNode;
		var splittedBox=el;
		var newBox=null;
		var newSplit=null;
		var newEl=null;
		var oldFiles=splittedBox.files;
		var oldDirs=splittedBox.dirs;
		// saving properties before cloning
		var path=splittedBox.getAttribute('path');
		var deckValue=splittedBox.getAttribute('deck');
		// end saving
		if (direction=='horizontal') {
			newBox=document.createElement('hbox');
		} else if (direction=='vertical') {
			newBox=document.createElement('vbox');
		}
		newBox.setAttribute('flex',1);
		newSplit=document.createElement('splitter');
		newEl=document.createElement('box');

		newEl.setAttribute('deck',deckValue);
		newEl.setAttribute('path',path);
		newEl.setAttribute('persist','path deck width height');

		newEl.setAttribute('class','filebox');
		newEl.setAttribute('flex',1);
		fireflyIdNum++;
		newEl.setAttribute('id','id'+fireflyIdNum);
		newEl.setAttribute('onfocus',"focus_tasks(this);");
		newEl.setAttribute('onblur','blur_tasks(this);');
		//newEl.setAttribute('onclick','unfoldTree(this)');
		newEl.setAttribute('changeDeck',"setDeck(1,document.getElementById('containing_deck'));");
		parent.insertBefore(newBox,splittedBox.nextSibling);
		newBox.appendChild(splittedBox);
		newBox.appendChild(newSplit);
		newBox.appendChild(newEl);
		
		newBox.firstChild.files=oldFiles;
		newBox.firstChild.dirs=oldDirs;
		newBox.firstChild.refresh();
		newBox.childNodes[2].refresh();
	} catch (e) {
		errorLogger(e);
	}
}

function close_split(el) {
	/* Closing the splitted view */
	try {
		var parent=el.parentNode;
		var toRemove=el;
		var idToStay;
		var path;
		var deck;
		var parentParent=parent.parentNode;
		if (toRemove.id!='firstBox') {		// the first view can not be closed!!!
			if (toRemove.previousSibling!=null) {
				parent.removeChild(toRemove.previousSibling);
				parentParent.insertBefore(toRemove.previousSibling,parent.nextSibling);
			} else if (toRemove.nextSibling!=null) {
				parent.removeChild(toRemove.nextSibling);
				parentParent.insertBefore(toRemove.nextSibling,parent.nextSibling);
			}
			parent.removeChild(toRemove);
			parentParent.removeChild(parent);
			document.getElementById('containing_deck').setAttribute('currentSubwindow','firstBox')
			document.getElementById('firstBox').focus();
		}
	} catch (e) {
		errorLogger(e);
	}
}

function setDeck(index,el) {
	/* Change between details,list... views or between fulscreen and not */
	el.setAttribute("selectedIndex",index);
	if (el.id!='containing_deck'){
		el.parentNode.setAttribute('deck',index);
		el.parentNode.refresh();
	} else {
		if (index==1) {
			getContent(el);			// get current subwindow properties and set them to the fullscreen view
		} else {
			setContent(el);			// get the fullscreen view properties and set them to the subwindow
		}
	}
}

function getContent(el) {
	// get current subwindow properties and set them to the fullscreen view
	try {
		var currentSubwindow=el.getAttribute('currentSubwindow');
		var pathValue=document.getElementById(currentSubwindow).getAttribute('path');
		var deckValue=document.getElementById(currentSubwindow).getAttribute('deck');
		el.firstChild.nextSibling.setAttribute('path',pathValue);
		el.firstChild.nextSibling.setAttribute('deck',deckValue);
		el.firstChild.nextSibling.refresh();
	} catch (e) {
		errorLogger(e);
	}
}

function setContent(el) {
	// get the fullscreen view properties and set them to the subwindow
	try {
		var currentSubwindow=el.getAttribute('currentSubwindow');
		var pathValue=el.firstChild.nextSibling.getAttribute('path');
		var deckValue=el.firstChild.nextSibling.getAttribute('deck');
		document.getElementById(currentSubwindow).setAttribute('path',pathValue);
		document.getElementById(currentSubwindow).setAttribute('deck',deckValue);
		document.getElementById(currentSubwindow).refresh();
	} catch (e) {
		errorLogger(e);
	}
}
function focus_tasks(el) {
	/* tasks executed when the subwindow is focused */
	try {
		//if (getCurrent().path.indexOf('search in:')!=-1 || getCurrent().path.indexOf('search:')!=-1) {
		if (getCurrent().type=='search') {
			document.getElementById('firefly_search').checked=true;
		}
		
		document.getElementById('firefly_filter').value=getCurrent().getAttribute('filter');
		
		var oldEl=document.getElementById('containing_deck').getAttribute('currentSubwindow');
		var path=el.path;
		if (getCurrent().type=='search') {
			path=path.substr(translate('search').length);
		}
		/*if (path.indexOf('search in:')!=-1){
			var searchStr='search in:'
			path=path.substr(searchStr.length);
		} else if (path.indexOf('search:')!=-1) {
			var searchStr='search:'
			path=path.substr(searchStr.length);
		}*/

		// display free space in statusbar
		var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance();
		if (aFile) aFile.QueryInterface(Components.interfaces.nsILocalFile);
		aFile.initWithPath(path);
		var diskSpaceAvailable=aFile.diskSpaceAvailable;
		if ((diskSpaceAvailable/1024)<1024) {
			var space=Math.ceil(aFile.diskSpaceAvailable/1024);
			var statusMessage=space+' '+translate('kbfreeStatusbar');
		} else if (((diskSpaceAvailable/1024)/1024)<1024) {
			var space=((aFile.diskSpaceAvailable/1024)/1024);
			var statusMessage=space.toFixed(2)+' '+translate('mbfreeStatusbar');
		} else {
			var space=(((aFile.diskSpaceAvailable/1024)/1024)/1024);
			var statusMessage=space.toFixed(2)+' '+translate('gbfreeStatusbar');
		}
		window.status=statusMessage;
		
		// set addressbox to the subwindow path and set the active window(the border too)
		document.getElementById('firefly_addresbox').value=el.path;
		document.getElementById('containing_deck').setAttribute('currentSubwindow',el.id);
		if (document.getElementById(oldEl)) document.getElementById(oldEl).setAttribute('style','border:2px solid grey;');
		el.setAttribute('style','border:2px solid black;');
		unfoldTree();			// tell the sidebar tree to select the current path and to unfold accordingly
		el.setAttribute('hasFocus','true');
		//el.refresh();	// why is needed??? prevents thumbnails from working
	} catch (e) {
		errorLogger(e);
	}
}
function blur_tasks(el) {
	el.setAttribute('hasFocus','false');
}
function unfoldTree() {
	// tell the sidebar tree to select the current path and to unfold accordingly
	try {
		//var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var win = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
			   .getInterface(Components.interfaces.nsIWebNavigation)
			   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
			   .rootTreeItem
			   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
			   .getInterface(Components.interfaces.nsIDOMWindow);
		var a = win.document.getElementById("sidebar-box");
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var auto_open_sidebar=prefs.getBoolPref('extensions.firefly.auto_open_sidebar');
		if (auto_open_sidebar) {
			if (a.hidden) win.toggleSidebar('viewFoldersSidebar');
		}
		if (!a.hidden) {
			var tree=win.document.getElementById('sidebar').contentDocument.getElementById('elementList');
			var path=document.getElementById('firefly_addresbox').value;
			if (tree) {
				tree.view.performAction(path);
			}
		}
	} catch (e) {
		errorLogger(e);
	}
}
function refreshMenu(el) {
	/* Display views menu selecting the appropriate view and chacking if IETab is installed */
	try {
		var deckValue=document.getElementById(document.getElementById('containing_deck').getAttribute('currentSubwindow')).deck;
		for (var i=0;i<el.childNodes.length;i++) {
			if (i==5) {
				if (!pluginExists('PCMan\'s IE Tab Plug-in for Mozilla/Firefox')){
					document.getElementById('cmd_ieView').setAttribute('disabled','true');
				}
			}
			if (i==deckValue) {
				el.childNodes[i].setAttribute('checked',true);
			} else {
				el.childNodes[i].setAttribute('checked',false);
			}
		}
	} catch (e) {
		errorLogger(e);
	}
}
function fullscreen() {
	/* Changing between fullscreen and not */
	var deck=document.getElementById('containing_deck');
	if (deck.selectedIndex==0 || deck.selectedIndex=="") {
		setDeck(1,deck);
		document.getElementById('firefly_splith').hidden=true;
		document.getElementById('firefly_splitv').hidden=true;
		document.getElementById('firefly_close').hidden=true;
		document.getElementById('separatorToHide').hidden=true;
		document.getElementById('firefly_fullscreen').setAttribute('style',"list-style-image: url('chrome://firefly/skin/from_fullscreen-20.gif');-moz-image-region: rect(0px 18px 20px -3px);");
		document.getElementById('firefly_fullscreen').setAttribute('tooltiptext',translate('btnDecrease'));
	} else {
		setDeck(0,deck);		
		document.getElementById('firefly_splith').hidden=false;
		document.getElementById('firefly_splitv').hidden=false;
		document.getElementById('firefly_close').hidden=false;
		document.getElementById('separatorToHide').hidden=false;
		document.getElementById('firefly_fullscreen').setAttribute('style',"list-style-image: url('chrome://firefly/skin/to_fullscreen-20.gif');-moz-image-region: rect(0px 18px 20px -3px);");
		document.getElementById('firefly_fullscreen').setAttribute('tooltiptext',translate('btnExpand'));
	}
}
function getCurrent() {
	/* Get the current subwindow */
	return document.getElementById(document.getElementById('containing_deck').getAttribute('currentSubwindow'));
}

function doTimer() {
	/* Timer - refreshes every second the progress when in the tooltip there is video or audio preview */
	var progress=Math.ceil(((document.getElementById('tooltipVideo').get_time())/(document.getElementById('tooltipVideo').get_length()))*100);
	document.getElementById('tooltipProgress').setAttribute('value',progress);
	fireflyTimeout = setTimeout("doTimer();", 1000);
}

function sortby(what) {
	/* Set the sort criteria */
	getCurrent().setAttribute('sortby',what);
	var sortDir=getCurrent().getAttribute('sortDir');
	if (sortDir=='' || sortDir=='desc') {
		getCurrent().setAttribute('sortDir','asc');
	} else {
		getCurrent().setAttribute('sortDir','desc');
	}
	getCurrent().refresh();
}

function createFile(type) {
	/* Create new file/folder from the context menu */
	try {
		var path=getCurrent().path;
		//if (path.indexOf('search in:')!=-1 || path.indexOf('search:')!=-1) {
		if (getCurrent().type=='search') {
			path=path.substr(translate('search').length);
			/*if (path.indexOf('search in:')!=-1){
				var searchStr='search in:'
				path=path.substr(searchStr.length);
			} else if (path.indexOf('search:')!=-1) {
				var searchStr='search:'
				path=path.substr(searchStr.length);
			}*/
		}
		var aFolder = Components.classes["@mozilla.org/file/local;1"].createInstance();
		if (aFolder) aFolder.QueryInterface(Components.interfaces.nsILocalFile);
		aFolder.initWithPath(path);
		if (type==0) {
			aFolder.append(translate('lblNewFile'));
			aFolder.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
		} else {
			aFolder.append(translate('lblNewFolder'));
			aFolder.createUnique(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);
		}
		getCurrent().refresh();
	} catch (e) {
		errorLogger(e);
	}
}

function fileDelete() {
	/* Delete file/folder from the context menu */
	try {
		var path=getCurrent().path;
		var aFolder = Components.classes["@mozilla.org/file/local;1"].createInstance();
		if (aFolder) aFolder.QueryInterface(Components.interfaces.nsILocalFile);
		var filesToDelete=getCurrent().selectedFiles;
		var message=translate('deleteAlert');
		for (var i=0;i<filesToDelete.length;i++) {
			message+=filesToDelete[i]+'\r\n';
		}
		if(confirm(message)) {
			if (filesToDelete.length>0) {
				for (var i=0;i<filesToDelete.length;i++) {
					aFolder.initWithPath(path);
					aFolder.append(filesToDelete[i]);
					aFolder.remove(true);
				}
			}
		}
		
		getCurrent().refresh();
	} catch (e) {
		errorLogger(e);
	}
}
function fileRename() {
	/* Rename the file/folder */
	//var path=getCurrent().path;
	try {
		var path=document.getElementById('filePopup').getAttribute('path')
		var aFolder = Components.classes["@mozilla.org/file/local;1"].createInstance();
		if (aFolder) aFolder.QueryInterface(Components.interfaces.nsILocalFile);
		aFolder.initWithPath(path);
		aFolder.append(document.getElementById('filePopup').getAttribute('name'));
		
		window.openDialog('chrome://firefly/content/renameDialog.xul',"showmore","chrome,modal",aFolder);
	} catch (e) {
		errorLogger(e);
	}
}

function dirSizeCalc(dir,multiplier) {
	/* Calculate the dir size for the tooltip - 
		currently calculated size is stored in an attribute of the size description 
		new dirs when scanned are added to an array
		multiplier is used to minimize possibility of UI lock
	*/
	try {
		var sizeDesc=document.getElementById('fileSize');
		
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var dirScanInterval=prefs.getIntPref('extensions.firefly.dir_scan_interval');
		var dirs=new Array();
		var files=new Array();
		var next;
		var aFolder = Components.classes["@mozilla.org/file/local;1"].createInstance();
		if (aFolder) aFolder.QueryInterface(Components.interfaces.nsILocalFile);
		aFolder.initWithPath(dir);
		var folderEntries=aFolder.directoryEntries;
		while (folderEntries.hasMoreElements()) {
			next=folderEntries.getNext().QueryInterface(Components.interfaces.nsILocalFile);
			if (next.isDirectory()) {
				dirs.push(next);
			} else {
				files.push(next);
			}
		}
		dirs.sort(nameSort);
		files.sort(nameSort);
		var filesANDdirs=Array.concat(dirs,files);
		multiplier++;
		for (var i=0;i<filesANDdirs.length;i++) {
			if (filesANDdirs[i].isDirectory()) {
				fireflyDirName=filesANDdirs[i].path;
				fireflyDirName=fireflyDirName.replace(/\\/g,'\\\\');
				setTimeout('dirSizeCalc("'+fireflyDirName+'",'+multiplier+')',(multiplier+i)*dirScanInterval);
			} else {
				try {
					sizeDesc.setAttribute('size',(Math.ceil(sizeDesc.getAttribute('size'))+Math.ceil(filesANDdirs[i].fileSize)));
					sizeDesc.value=translate('sizeTooltipCalc') +Math.ceil(sizeDesc.getAttribute('size')/1024).toLocaleString()+' '+translate('kbProgress');
				} catch (e) {
					return null;
				}
			}
		}
	} catch (e) {
		errorLogger(e);
	}
	return null;
}

function checkPopup(event) {
	/* When right clicking a tree row a context menu is shown - 
		it is the same for filled rows and the empty ones in the end 
		so we check if we are on the empty rows(-1) and if yes 
		hide the shown menu and display the correct one
	*/
	var deck=getCurrent().deck;
	if (deck==0) {
		var treeElement=event.rangeParent;
		var row = new Object();
		var col = new Object();
		var childElement = new Object();
		if (treeElement && treeElement.treeBoxObject) {
			treeElement.treeBoxObject.getCellAt(event.clientX, event.clientY, row, col, childElement);
			if (row.value==-1) {
				setTimeout('document.getElementById("filePopup").hidePopup()',1);
				document.getElementById('contextPopup').showPopup(event.target,-1,-1,'context');
			} else {
				
			}
		}
	}
}
function showSendTo(menu) {
	/* Construct SendTo menu from users preferences */
	var newSubMenu;
	//var menu=document.getElementById('sendToMenu');
	
	eraseContent(menu);
	
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	//dump('\r\n'+prefs+'\r\n');
	//prefs = prefs.getBranch("extensions.firefly.");
	var openWithVal=prefs.getCharPref('extensions.firefly.send_to_string');

	var openWithArray=new Array();
	openWithArray=openWithVal.split('|');
	for (var i=0;i<openWithArray.length;i++) {
		newSubMenu=document.createElement('menuitem');
		var val=openWithArray[i].split('=');
		newSubMenu.setAttribute('label',val[1]);
		newSubMenu.setAttribute('value',val[0]);
		menu.appendChild(newSubMenu);
	}
	menu.appendChild(document.createElement('menuseparator'));
	newSubMenu=document.createElement('menuitem');
	newSubMenu.setAttribute('label',translate('chooseLabel'));
	newSubMenu.setAttribute('id','chooseDir');
	menu.appendChild(newSubMenu);
}
function sendTo(event) {
	/* Do send to the corresponding directory */
	try {
		var target=event.target;
		//here will be the sending to code after i make copy/paste work
		if (target.id=='chooseDir') {
			var nsIFilePicker = Components.interfaces.nsIFilePicker;
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
			fp.init(window, translate('wndSelectFolder'), nsIFilePicker.modeGetFolder);//#  Available modes: modeOpen, modeSave, modeGetFolder, modeOpenMultiple.
			
			
			var res = fp.show();
			if (res == nsIFilePicker.returnOK){
				var file = fp.file;
			}
		} else {
			var file = Components.classes["@mozilla.org/file/local;1"]
				     .createInstance(Components.interfaces.nsILocalFile);
			file.initWithPath(target.value);
		}
		if (file) {
			copyFiles();
			pasteFiles(file.path);
		}
	} catch (e) {
		errorLogger(e);
	}
}
function openWith(event) {
	/* Do open with the correspondingly selected application */
	try {
		var target=event.target;
		
		if (target.id=='chooseApp') {
			var nsIFilePicker = Components.interfaces.nsIFilePicker;
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
			fp.init(window,translate('wndSelectFile'), nsIFilePicker.modeOpen);//#  Available modes: modeOpen, modeSave, modeGetFolder, modeOpenMultiple.
			fp.appendFilters(nsIFilePicker.filterApps);//# Available filters: filterAll, filterHTML, filterText, filterImages, filterXML, filterXUL, filterApps. 
			fp.filterIndex=nsIFilePicker.filterApps;
			
			var res = fp.show();
			if (res == nsIFilePicker.returnOK){
				var file = fp.file;
			}
		} else {
			var file = Components.classes["@mozilla.org/file/local;1"]
				     .createInstance(Components.interfaces.nsILocalFile);
			file.initWithPath(target.value);
		}
		if (file) {
			// create an nsIProcess
			var process = Components.classes["@mozilla.org/process/util;1"]
						.createInstance(Components.interfaces.nsIProcess);
			process.init(file);

			//var path=getCurrent().path;
			var path=document.getElementById('filePopup').getAttribute('path');
			var aFolder = Components.classes["@mozilla.org/file/local;1"].createInstance();
			if (aFolder) aFolder.QueryInterface(Components.interfaces.nsILocalFile);
			aFolder.initWithPath(path);
			aFolder.append(document.getElementById('filePopup').getAttribute('name'));

			// Run the process.
			// If first param is true, calling process will be blocked until
			// called process terminates. 
			// Second and third params are used to pass command-line arguments
			// to the process.
			var args = [aFolder.path];
			process.run(false, args, args.length);
		}
	} catch (e) {
		errorLogger(e);
	}
}
function showOpenWith() {
	/* Construct Open With menu from user preferences */
	var newSubMenu;
	var menu=document.getElementById('openWithMenu');
	
	eraseContent(menu);
	
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	//dump('\r\n'+prefs+'\r\n');
	//prefs = prefs.getBranch("extensions.firefly.");
	var openWithVal=prefs.getCharPref('extensions.firefly.open_with_string');

	var openWithArray=new Array();
	openWithArray=openWithVal.split('|');
	for (var i=0;i<openWithArray.length;i++) {
		newSubMenu=document.createElement('menuitem');
		var val=openWithArray[i].split('=');
		newSubMenu.setAttribute('label',val[1]);
		newSubMenu.setAttribute('value',val[0]);
		menu.appendChild(newSubMenu);
	}
	menu.appendChild(document.createElement('menuseparator'));
	newSubMenu=document.createElement('menuitem');
	newSubMenu.setAttribute('label',translate('chooseLabel'));
	newSubMenu.setAttribute('id','chooseApp');
	menu.appendChild(newSubMenu);
}
function createShortcut() {
	// does nothing for now - need to find a crossplatform way to create shortcuts!!!
	//var path=getCurrent().path;
	var path=document.getElementById('filePopup').getAttribute('path');
	var aFolder = Components.classes["@mozilla.org/file/local;1"].createInstance();
	if (aFolder) aFolder.QueryInterface(Components.interfaces.nsILocalFile);
	aFolder.initWithPath(path);
	aFolder.append(document.getElementById('filePopup').getAttribute('name'));
	//aFolder.
}
function showProperties() {
	/* Open the file properties dialog */
	//var path=getCurrent().path;
	try {
		var path=document.getElementById('filePopup').getAttribute('path');
		var aFolder = Components.classes["@mozilla.org/file/local;1"].createInstance();
		if (aFolder) aFolder.QueryInterface(Components.interfaces.nsILocalFile);
		aFolder.initWithPath(path);
		aFolder.append(document.getElementById('filePopup').getAttribute('name'));
		
		window.openDialog('chrome://firefly/content/fileProperties.xul',"showmore","chrome",aFolder);
	} catch (e) {
		errorLogger(e);
	}
}
function pluginExists(pluginName) {
	/* Check if the plugin exists - by the name displayed - not the file name - wouldn't be the same in Win/Linux (dll/so) */
	var plugins=navigator.plugins;
	for (var i=0;i<plugins.length;i++) {
		if (plugins[i].name.indexOf(pluginName)!=-1) {
			return true;
		}
	}
	return false;
}
function doFilter(value,add) {
	/* set the filter attribute so that folder content is filtered */
	//if ((getCurrent().path.indexOf('search in:')!=-1 || getCurrent().path.indexOf('search:'))!=-1 && add) {
	var FormHistory;
	if ("nsIFormHistory2" in Components.interfaces)
		FormHistory = Components.classes["@mozilla.org/satchel/form-history;1"]
		.getService(Components.interfaces.nsIFormHistory2);
	else if ("nsIFormHistory" in Components.interfaces)
		FormHistory = Components.classes["@mozilla.org/satchel/form-history;1"]
		.getService(Components.interfaces.nsIFormHistory);
	if (getCurrent().type=='search' && add) {
		getCurrent().files=new Array();
		getCurrent().dirs=new Array();
		//var FormHistory = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory);
		if (FormHistory && !FormHistory.entryExists('firefly_filter',value)) {
			FormHistory.addEntry('firefly_filter',value);
		}
		getCurrent().setAttribute('filter',value);
		
		var path;
		path=getCurrent().path.substr(translate('search').length);
		/*if (getCurrent().path.indexOf('search in:')!=-1){
			var searchStr='search in:'
			path=getCurrent().path.substr(searchStr.length);
		} else if (getCurrent().path.indexOf('search:')!=-1) {
			var searchStr='search:'
			path=getCurrent().path.substr(searchStr.length);
		}*/
		
		searchInDir(path,0);
		getCurrent().refresh();
	} else {
		if (add) {
// 			var FormHistory = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory);
			if (FormHistory && !FormHistory.entryExists('firefly_filter',value)) {
				FormHistory.addEntry('firefly_filter',value);
			}
		}
		getCurrent().setAttribute('filter',value);
		getCurrent().refresh();
	}
}
function searchInDir(dir,multiplier) {
	/* Searching in dirs - 
		currently found files and dirs are stored in a property of the file box 
		new dirs when scanned are added to an array
		multiplier is used to minimize possibility of UI lock*/
	try {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var dirScanInterval=prefs.getIntPref('extensions.firefly.dir_scan_interval');
		var dirs=new Array();
		var files=new Array();
		var next;
		var aFolder = Components.classes["@mozilla.org/file/local;1"].createInstance();
		if (aFolder) aFolder.QueryInterface(Components.interfaces.nsILocalFile);
		aFolder.initWithPath(dir);
		var folderEntries=aFolder.directoryEntries;
		while (folderEntries.hasMoreElements()) {
			next=folderEntries.getNext().QueryInterface(Components.interfaces.nsILocalFile);
			if (next.isDirectory()) {
				getCurrent().dirs.push(next);
				dirs.push(next);
			} else {
				getCurrent().files.push(next);
				files.push(next);
			}
		}
		dirs.sort(nameSort);
		files.sort(nameSort);
		var filesANDdirs=Array.concat(dirs,files);
		multiplier++;
		for (var i=0;i<filesANDdirs.length;i++) {
			if (filesANDdirs[i].isDirectory()) {
				fireflyDirName=filesANDdirs[i].path;
				fireflyDirName=fireflyDirName.replace(/\\/g,'\\\\');
				setTimeout('searchInDir("'+fireflyDirName+'",'+multiplier+')',(multiplier+i)*dirScanInterval*2);
			}
		}
		getCurrent().refresh();
	} catch (e) {
		errorLogger(e);
	}
	return null;
}
function debug(aMsg) {
	setTimeout(function() { throw new Error("[debug] " + aMsg); }, 0);
}
function copyFiles() {
	/* Set copy files properties */
	gFireflySelectedFiles=getCurrent().selectedFiles2;
	document.getElementById('containing_deck').setAttribute('copiedFiles',getCurrent().selectedFiles);
	document.getElementById('containing_deck').setAttribute('sourceDir',getCurrent().path);
	document.getElementById('containing_deck').setAttribute('operation','copy');
	document.getElementById('cmd_paste').setAttribute('disabled',false);
}
function cutFiles() {
	/* Set cut files properties */
	gFireflySelectedFiles=getCurrent().selectedFiles2;
	document.getElementById('containing_deck').setAttribute('copiedFiles',getCurrent().selectedFiles);
	document.getElementById('containing_deck').setAttribute('sourceDir',getCurrent().path);
	document.getElementById('containing_deck').setAttribute('operation','cut');
	document.getElementById('cmd_paste').setAttribute('disabled',false);
}
function pasteFiles(destinationDir) {
	/* Create new transfer job */
	try {
		if (destinationDir=='') {
			destinationDir=getCurrent().path;
		} 
		//var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var win = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
			   .getInterface(Components.interfaces.nsIWebNavigation)
			   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
			   .rootTreeItem
			   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
			   .getInterface(Components.interfaces.nsIDOMWindow);
		var mainDoc=win.document;
		var transferSpacer=mainDoc.createElement('label');
		transferSpacer.setAttribute('class','hiddenTransfer');
		
		transferSpacer.sourceDir=document.getElementById('containing_deck').getAttribute('sourceDir');
		transferSpacer.destinationDir=destinationDir;
		transferSpacer.operation=document.getElementById('containing_deck').getAttribute('operation');
		transferSpacer.filesAndDirs=gFireflySelectedFiles;//document.getElementById('containing_deck').getAttribute('copiedFiles');
		
		document.getElementById('containing_deck').setAttribute('sourceDir','');
		document.getElementById('containing_deck').setAttribute('operation','');
		document.getElementById('containing_deck').setAttribute('copiedFiles','');
		
		win.document.getElementById('fireflyTransferStatus').appendChild(transferSpacer);
		document.getElementById('cmd_paste').setAttribute('disabled',true);
	} catch (e) {
		errorLogger(e);
	}
}
function openInEditor() {
	/* Open the last selected file in the editor selected in preferences */
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var editor_preference=prefs.getCharPref('extensions.firefly.external_editor_path');
	if (editor_preference!='') {
		try {
			var file = Components.classes["@mozilla.org/file/local;1"]
					     .createInstance(Components.interfaces.nsILocalFile);
			file.initWithPath(editor_preference);
			
			var process = Components.classes["@mozilla.org/process/util;1"]
						.createInstance(Components.interfaces.nsIProcess);
			process.init(file);

			//var path=getCurrent().path;
			var path=document.getElementById('filePopup').getAttribute('path');
			var aFolder = Components.classes["@mozilla.org/file/local;1"].createInstance();
			if (aFolder) aFolder.QueryInterface(Components.interfaces.nsILocalFile);
			aFolder.initWithPath(path);
			aFolder.append(document.getElementById('filePopup').getAttribute('name'));

			// Run the process.
			// If first param is true, calling process will be blocked until
			// called process terminates. 
			// Second and third params are used to pass command-line arguments
			// to the process.
			var args = [aFolder.path];
			process.run(false, args, args.length);
		} catch (e) {
			errorLogger(e);
		}
	}
}
function sortSubwindowsVert(el1,el2) {
	if (el1.boxObject.y<el2.boxObject.y) {
		return -1;
	} else if (el1.boxObject.y>el2.boxObject.y) {
		return 1;
	} else {
		return 0;
	}
}
function sortSubwindowsHor(el1,el2) {
	if (el1.boxObject.x<el2.boxObject.x) {
		return -1;
	} else if (el1.boxObject.x>el2.boxObject.x) {
		return 1;
	} else {
		return 0;
	}
}
function navigate(direction) {
	try {
		var element=getCurrent();
		var x=element.boxObject.x;
		var y=element.boxObject.y;
		var hits=new Array();
		var found=null;
		switch (direction) {
			case 'up':
			case 'down':
				if (document.getElementById('firstBox').boxObject.x==x) {
					hits.push(document.getElementById('firstBox'));
				}
				for (var i=1;i<=fireflyIdNum;i++) {
					if (document.getElementById('id'+i) && document.getElementById('id'+i).boxObject.x==x) {
						hits.push(document.getElementById('id'+i));
					}
				}
				break;
			case 'left':
			case 'right':
				if (document.getElementById('firstBox').boxObject.y==y) {
					hits.push(document.getElementById('firstBox'));
				}
				for (var i=1;i<=fireflyIdNum;i++) {
					if (document.getElementById('id'+i) && document.getElementById('id'+i).boxObject.y==y) {
						hits.push(document.getElementById('id'+i));
					}
				}
				break;
		}
		if (hits.length!=0) {
			switch (direction) {
				case 'up':
					hits.sort(sortSubwindowsVert);
					for (var i=0;i<hits.length;i++) {
						if (hits[i].boxObject.y==y) {
							break;
						} else {
							found=hits[i];
						}
					}
					break;
				case 'down':
					var bFound=false;
					hits.sort(sortSubwindowsVert);
					for (var i=0;i<hits.length;i++) {
						if (hits[i].boxObject.y==y) {
							bFound=true;
							continue;
						} else {
							found=hits[i];
						}
						if (bFound) break;
					}
					break;
				case 'left':
					hits.sort(sortSubwindowsHor);
					for (var i=0;i<hits.length;i++) {
						if (hits[i].boxObject.x==x) {
							break;
						} else {
							found=hits[i];
						}
					}
					break;
				case 'right':
					var bFound=false;
					hits.sort(sortSubwindowsHor);
					for (var i=0;i<hits.length;i++) {
						if (hits[i].boxObject.x==x) {
							bFound=true;
							continue;
						} else {
							found=hits[i];
						}
						if (bFound) break;
					}
					break;
			}
		}
		if (found && found!=null) {
			document.getElementById('filePopup').setAttribute('name','');
			document.getElementById('filePopup').setAttribute('path','');
			found.focus();
		}
	} catch (e) {
		errorLogger(e);
	}
}
function search() {
	//if (getCurrent().path.indexOf('search in:')!=-1 || getCurrent().path.indexOf('search:')!=-1) {
	if (getCurrent().type=='search') {
		document.getElementById('firefly_search').checked=false;
		var path='';
		path=getCurrent().path.substr(translate('search').length);
		/*if (getCurrent().path.indexOf('search in:')!=-1){
			var searchStr='search in:'
			path=getCurrent().path.substr(searchStr.length);
		} else if (getCurrent().path.indexOf('search:')!=-1) {
			var searchStr='search:'
			path=getCurrent().path.substr(searchStr.length);
		}*/
		document.getElementById('firefly_addresbox').value=path;
		getCurrent().type='file';
		getCurrent().path=path;
	} else {
		document.getElementById('firefly_search').checked=true;
		document.getElementById('firefly_addresbox').value=translate('search')+getCurrent().path;/*'search in:'*/
		getCurrent().type='search';
		getCurrent().path=document.getElementById('firefly_addresbox').value;
	}
	getCurrent().refresh();
}

function errorLogger(e) {
	
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var alertErrors=prefs.getBoolPref('extensions.firefly.alert_errors');
	if (alertErrors) {
		alert(e.message);
	}
	
	var date=new Date();
	var data='File name:'+(e.fileName?e.fileName:'')+'\tLine number:'+(e.lineNumber?e.lineNumber:'')+
		'\tDate:'+date.getDate()+'.'+date.getMonth()+'.'+date.getFullYear()+'\t'+date.getHours()+':'+date.getMinutes()+':'+date.getSeconds()+
		'\tMessage:'+(e.message?e.message:'')+'\tName:'+(e.name?e.name:'')+'\tConstructor:'+(e.constructor?e.constructor:'')+'\r\n';
	var file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
	file.append('firefly.err');
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                         .createInstance(Components.interfaces.nsIFileOutputStream);
	
	if (file.exists()) {
		if (file.fileSize>20000) {
			foStream.init(file,  0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
		} else {
			foStream.init(file,  0x02 | 0x08 | 0x10, 0664, 0); // write, create, append
		}
	} else {
		foStream.init(file,  0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
		
	}
	
	
	foStream.write(data, data.length);
	foStream.close();
}

function getOS() {
	var os =navigator.platform;
	if (os.toLowerCase().indexOf('linux')!=-1) {
		return 'linux';
	}
	if (os.toLowerCase().indexOf('win')!=-1) {
		return 'windows';
	}
	if (os.toLowerCase().indexOf('mac')!=-1) {
		return 'mac';
	}
	if (os.toLowerCase().indexOf('power')!=-1) {
		return 'powerpc';
	}
	if (os.toLowerCase().indexOf('sun')!=-1) {
		return 'sunos';
	}
	if (os.toLowerCase().indexOf('sol')!=-1) {
		return 'solaris';
	}
}